## libcrypto++ 5.6.4

=== CMakeLists.txt ===
# Please ensure your changes or patch meets minimum requirements.
#   The minimum requirements are below, and they are 2.8.5. Please
#   do not check in something for 2.8.12. To test your changes,
#   please set up a Ubuntu 12.04 LTS system. Then, manually install
#   Cmake 2.8.5 from http://cmake.org/Wiki/CMake_Released_Versions.

cmake_minimum_required(VERSION 2.8.5 FATAL_ERROR)

project(cryptopp)

set(cryptopp_VERSION_MAJOR 5)
set(cryptopp_VERSION_MINOR 6)
set(cryptopp_VERSION_PATCH 4)

include(GNUInstallDirs)
include(TestBigEndian)

#============================================================================
# Settable options
#============================================================================

option(BUILD_STATIC "Build static library" ON)
option(BUILD_SHARED "Build shared library" ON)
option(BUILD_TESTING "Build library tests" ON)
option(BUILD_DOCUMENTATION "Use Doxygen to create the HTML based API documentation" OFF)

option(DISABLE_ASM "Disable ASM" OFF)
option(DISABLE_SSSE3 "Disable SSSE3" OFF)
option(DISABLE_AESNI "Disable AES-NI" OFF)
set(CRYPTOPP_DATA_DIR "" CACHE PATH "Crypto++ test data directory")

#============================================================================
# Internal compiler options
#============================================================================

# Don't use RPATH's. The resulting binary could fail a security audit.
if (NOT CMAKE_VERSION VERSION_LESS 2.8.12)
  set(CMAKE_MACOSX_RPATH 0)
endif()

set(LIB_VER ${cryptopp_VERSION_MAJOR}${cryptopp_VERSION_MINOR}${cryptopp_VERSION_PATCH})

if(CMAKE_CXX_COMPILER_ID MATCHES "Intel")
	add_definitions(-wd68 -wd186 -wd279 -wd327 -wd161 -wd3180)
endif()

# Endianess
TEST_BIG_ENDIAN(IS_BIG_ENDIAN)
if(IS_BIG_ENDIAN)
	add_definitions(-DIS_BIG_ENDIAN)
endif()

if(DISABLE_ASM)
	add_definitions(-DCRYPTOPP_DISABLE_ASM)
endif()
if(DISABLE_SSSE3)
	add_definitions(-DCRYPTOPP_DISABLE_SSSE3)
endif()
if(DISABLE_AESNI)
	add_definitions(-DCRYPTOPP_DISABLE_AESNI)
endif()
if(NOT CRYPTOPP_DATA_DIR STREQUAL "")
	add_definitions(-DCRYPTOPP_DATA_DIR="${CRYPTOPP_DATA_DIR}")
endif()

if(WINDOWS_STORE OR WINDOWS_PHONE)
	if("${CMAKE_SYSTEM_VERSION}" MATCHES "10\\.0.*")
		SET( CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} /D\"_WIN32_WINNT=0x0A00\"" )
	endif()
	SET( CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} /FI\"winapifamily.h\"" )
endif()
#============================================================================
# Sources & headers
#============================================================================

# Library headers
file(GLOB cryptopp_HEADERS *.h)

# Test sources. You can use the GNUmakefile to generate the list: `make sources`.
file(GLOB cryptopp_SOURCES_TEST bench1.cpp bench2.cpp test.cpp validat1.cpp validat2.cpp validat3.cpp adhoc.cpp datatest.cpp regtest.cpp fipsalgt.cpp dlltest.cpp fipstest.cpp)

# Library sources. You can use the GNUmakefile to generate the list: `make sources`.
file(GLOB cryptopp_SOURCES *.cpp)
list(REMOVE_ITEM cryptopp_SOURCES
		${CMAKE_CURRENT_SOURCE_DIR}/cryptlib.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/cpu.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/pch.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/simple.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/winpipes.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/cryptlib_bds.cpp
		${cryptopp_SOURCES_TEST}
		)
set(cryptopp_SOURCES
		${CMAKE_CURRENT_SOURCE_DIR}/cryptlib.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/cpu.cpp
		${cryptopp_SOURCES}
		)

if(MINGW OR WIN32)
	list(APPEND cryptopp_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/winpipes.cpp)
endif()

if(MSVC AND NOT DISABLE_ASM)
	if(${CMAKE_GENERATOR} MATCHES ".*ARM")
		message(STATUS "Disabling ASM because ARM is specified as target platform.")
	else()
		if(CMAKE_SIZEOF_VOID_P EQUAL 8)
			list(APPEND cryptopp_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/x64dll.asm)
			list(APPEND cryptopp_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/x64masm.asm)
			set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/x64dll.asm PROPERTIES COMPILE_FLAGS "/D_M_X64")
			set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/x64masm.asm PROPERTIES COMPILE_FLAGS "/D_M_X64")
			set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/rdrand.asm PROPERTIES COMPILE_FLAGS "/D_M_X64")
		else()
			set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/x64dll.asm PROPERTIES COMPILE_FLAGS "/D_M_X86 /safeseh")
			set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/x64masm.asm PROPERTIES COMPILE_FLAGS "/D_M_X86 /safeseh")
			set_source_files_properties(${CMAKE_CURRENT_SOURCE_DIR}/rdrand.asm PROPERTIES COMPILE_FLAGS "/D_M_X86 /safeseh")
		endif()
		list(APPEND cryptopp_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/rdrand.asm)
		enable_language(ASM_MASM)
	endif()
endif()

#============================================================================
# Compile targets
#============================================================================

# Set global includes BEFORE adding any targets for legacy CMake versions
if(CMAKE_VERSION VERSION_LESS 2.8.12)
	include_directories("${CMAKE_CURRENT_SOURCE_DIR}")
endif()

if(NOT CMAKE_VERSION VERSION_LESS 2.8.8)
	add_library(cryptopp-object OBJECT ${cryptopp_SOURCES})
endif()

if (BUILD_STATIC)
	if(NOT CMAKE_VERSION VERSION_LESS 2.8.8)
		add_library(cryptopp-static STATIC $<TARGET_OBJECTS:cryptopp-object>)
	else()
		add_library(cryptopp-static STATIC ${cryptopp_SOURCES})
	endif()

	if (NOT CMAKE_VERSION VERSION_LESS 2.8.12)
		target_include_directories(cryptopp-static PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}> $<INSTALL_INTERFACE:include/cryptopp>)
	endif()
endif()

if (BUILD_SHARED)
	if(NOT CMAKE_VERSION VERSION_LESS 2.8.8)
		add_library(cryptopp-shared SHARED $<TARGET_OBJECTS:cryptopp-object>)
	else()
		add_library(cryptopp-shared SHARED ${cryptopp_SOURCES})
	endif()

	if (NOT CMAKE_VERSION VERSION_LESS 2.8.12)
		target_include_directories(cryptopp-shared PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}> $<INSTALL_INTERFACE:include/cryptopp>)
	endif()
endif()

# Set PIC
if(CMAKE_SIZEOF_VOID_P EQUAL 8)
	# Enables -fPIC on all 64-bit platforms
	if(NOT CMAKE_VERSION VERSION_LESS 2.8.9)	# POSITION_INDEPENDENT_CODE support
		set_target_properties(cryptopp-object PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
	elseif(NOT CMAKE_VERSION VERSION_LESS 2.8.8)	# Object library support
		get_target_property(flags_old cryptopp-object COMPILE_FLAGS)
		set_target_properties(cryptopp-object PROPERTIES COMPILE_FLAGS "${flags_old} -fPIC")
	else()
		if (BUILD_STATIC)
			get_target_property(flags_old_static cryptopp-static COMPILE_FLAGS)
			if(NOT flags_old_static)
				set(flags_old_static "")
			endif()
			set_target_properties(cryptopp-static PROPERTIES COMPILE_FLAGS "${flags_old_static} -fPIC")
		endif()
		if (BUILD_SHARED)
			get_target_property(flags_old_shared cryptopp-shared COMPILE_FLAGS)
			if(NOT flags_old_shared)
				set(flags_old_shared "")
			endif()
			set_target_properties(cryptopp-shared PROPERTIES COMPILE_FLAGS "${flags_old_shared} -fPIC")
		endif()
	endif()
endif()

# Set filenames for targets to be "cryptopp"
if(NOT MSVC)
	set(COMPAT_VERSION ${cryptopp_VERSION_MAJOR}.${cryptopp_VERSION_MINOR})

	if (BUILD_STATIC)
		set_target_properties(cryptopp-static
				PROPERTIES
				OUTPUT_NAME cryptopp)
	endif()
	if (BUILD_SHARED)
		set_target_properties(cryptopp-shared
				PROPERTIES
				SOVERSION ${COMPAT_VERSION}
				OUTPUT_NAME cryptopp)
	endif()
endif()

# Targets, compatible with Crypto++ GNUMakefile
if (BUILD_STATIC)
	add_custom_target(static)
	add_dependencies(static cryptopp-static)
endif()
if (BUILD_SHARED)
	add_custom_target(dynamic)
	add_dependencies(dynamic cryptopp-shared)
endif()

#============================================================================
# Third-party libraries
#============================================================================
if(WIN32)
	if (BUILD_STATIC)
		target_link_libraries(cryptopp-static ws2_32)
	endif()
	if (BUILD_SHARED)
		target_link_libraries(cryptopp-shared ws2_32)
	endif()
endif()

find_package(Threads)
if (BUILD_STATIC)
	target_link_libraries(cryptopp-static ${CMAKE_THREAD_LIBS_INIT})
endif()
if (BUILD_SHARED)
	target_link_libraries(cryptopp-shared ${CMAKE_THREAD_LIBS_INIT})
endif()

#============================================================================
# Tests
#============================================================================
enable_testing()
if(BUILD_TESTING)
	add_executable(cryptest ${cryptopp_SOURCES_TEST})
	target_link_libraries(cryptest cryptopp-static)

	# Setting "cryptest" binary name to "cryptest.exe"
	if(NOT WIN32)
		set_target_properties(cryptest PROPERTIES OUTPUT_NAME cryptest.exe)
	endif()
	if(NOT TARGET cryptest.exe)
		add_custom_target(cryptest.exe)
		add_dependencies(cryptest.exe cryptest)
	endif()

	file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/TestData DESTINATION ${PROJECT_BINARY_DIR})
	file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/TestVectors DESTINATION ${PROJECT_BINARY_DIR})

	add_test(NAME build_cryptest COMMAND "${CMAKE_COMMAND}" --build ${CMAKE_BINARY_DIR} --target cryptest)
	add_test(NAME cryptest COMMAND $<TARGET_FILE:cryptest> v)
	set_tests_properties(cryptest PROPERTIES DEPENDS build_cryptest)
endif()

#============================================================================
# Doxygen documentation
#============================================================================
if(BUILD_DOCUMENTATION)
	find_package(Doxygen REQUIRED)

	set(in_source_DOCS_DIR "${CMAKE_CURRENT_SOURCE_DIR}/html-docs")
	set(out_source_DOCS_DIR "${PROJECT_BINARY_DIR}/html-docs")

	add_custom_target(docs ALL
			COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile -d CRYPTOPP_DOXYGEN_PROCESSING
			WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
			SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile
			)

	if(NOT ${in_source_DOCS_DIR} STREQUAL ${out_source_DOCS_DIR})
		add_custom_command(
				TARGET docs POST_BUILD
				COMMAND ${CMAKE_COMMAND} -E copy_directory "${in_source_DOCS_DIR}" "${out_source_DOCS_DIR}"
				COMMAND ${CMAKE_COMMAND} -E remove_directory "${in_source_DOCS_DIR}"
		)
	endif()
endif()

#============================================================================
# Install
#============================================================================
set(export_name "cryptopp-targets")

# Runtime package
if (BUILD_SHARED)
	install(
			TARGETS cryptopp-shared
			EXPORT ${export_name}
			DESTINATION ${CMAKE_INSTALL_LIBDIR}
			RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
			LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
			ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
	)
endif()

# Development package
if (BUILD_STATIC)
	install(TARGETS cryptopp-static EXPORT ${export_name} DESTINATION ${CMAKE_INSTALL_LIBDIR})
endif()
install(FILES ${cryptopp_HEADERS} DESTINATION include/cryptopp)

# CMake Package
if(NOT CMAKE_VERSION VERSION_LESS 2.8.8)	# CMakePackageConfigHelpers is supported from 2.8.8
	include(CMakePackageConfigHelpers)
	write_basic_package_version_file("${PROJECT_BINARY_DIR}/cryptopp-config-version.cmake" VERSION ${cryptopp_VERSION_MAJOR}.${cryptopp_VERSION_MINOR}.${cryptopp_VERSION_PATCH} COMPATIBILITY SameMajorVersion)
	install(FILES cryptopp-config.cmake ${PROJECT_BINARY_DIR}/cryptopp-config-version.cmake DESTINATION "lib/cmake/cryptopp")
	install(EXPORT ${export_name} DESTINATION "lib/cmake/cryptopp")
endif()

# Tests
if(BUILD_TESTING)
	install(TARGETS cryptest DESTINATION ${CMAKE_INSTALL_BINDIR})
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/TestData DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/cryptopp)
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/TestVectors DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/cryptopp)
endif()


# Documentation
if(BUILD_DOCUMENTATION)
	install(DIRECTORY "${out_source_DOCS_DIR}" DESTINATION ${CMAKE_INSTALL_DOCDIR})
endif()

=== debian/changelog ===
libcrypto++ (5.6.4-8) unstable; urgency=medium

  * Install all headers (closes: #866100).
  * Update watch file (closes: #862876).
  * Update Standards-Version to 4.0.0 and debhelper level to 10 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 27 Jun 2017 19:04:20 +0000

libcrypto++ (5.6.4-7) unstable; urgency=high

  * Backport security fix for out-of-bounds read in zinflate.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 05 Jun 2017 06:55:28 +0000

libcrypto++ (5.6.4-6) unstable; urgency=medium

  * Backport additional ASN.1 validations.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 25 Dec 2016 08:46:52 +0000

libcrypto++ (5.6.4-5) unstable; urgency=high

  * Fix CVE-2016-9939: possible DoS in ASN.1 decoders (closes: #848009).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 23 Dec 2016 20:54:36 +0000

libcrypto++ (5.6.4-4) unstable; urgency=medium

  * Apply upstream fix for Integer class ABI break (closes: #845460).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 02 Dec 2016 17:00:47 +0000

libcrypto++ (5.6.4-3) unstable; urgency=medium

  * Backport upstream fix for potential zeroizer removal.
  * Backport upstream fix for Hurd build.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 01 Nov 2016 11:27:35 +0000

libcrypto++ (5.6.4-2) unstable; urgency=low

  * Add missed headers to libcrypto++-dev (closes: #841443).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 23 Oct 2016 16:46:44 +0200

libcrypto++ (5.6.4-1) unstable; urgency=low

  * New upstream release.
  * Remove cryptest-data-files-location.diff as applied upstream.
  * Remove backported patches as this release contains those.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 08 Oct 2016 16:27:30 +0000

=== debian/control ===
Source: libcrypto++
Section: libs
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Standards-Version: 4.0.0
Build-Depends: debhelper (>= 10), automake, autoconf, libtool
Build-Depends-Indep: doxygen
Homepage: http://www.cryptopp.com

Package: libcrypto++6
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: General purpose cryptographic library - shared library
 General purpose cryptographic library for C++.
 .
 This package contains the shared libraries and should only be
 installed if other packages depend on it.

Package: libcrypto++6-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libcrypto++6 (= ${binary:Version}), ${misc:Depends}
Description: General purpose cryptographic library - debug symbols
 General purpose cryptographic library for C++.
 .
 This package contains the debug symbols for the shared library and
 should only be installed if you debugging a program that uses the
 shared library.

Package: libcrypto++-dev
Architecture: any
Section: libdevel
Depends: libcrypto++6 (= ${binary:Version}), ${misc:Depends}
Description: General purpose cryptographic library - C++ development
 Crypto++ is library for creating C++ programs which use cryptographic
 algorithms.  The library uses a Pipes & Filters architecture with heavy
 use of templates and abstract base classes.  The cryptographic
 tools include:
  * Authenticated encryption schemes (GCM, CCM, EAX),
  * High speed stream ciphers (Panama, Sosemanuk, Salsa20, XSalsa20),
  * AES and candidates (Rijndael, RC6, MARS, Twofish, Serpent, CAST-256),
  * Other symmetric block ciphers (IDEA, Triple-DES, Camellia, SEED,
    RC5, Blowfish, TEA, XTEA, Skipjack, SHACAL-2),
  * Block cipher modes of operation (ECB, CBC, CTS, CFB, OFB, CTR),
  * Message authentication codes (VMAC, HMAC, CMAC, CBC-MAC, DMAC,
    Two-Track-MAC),
  * Hash functions (SHA-1, SHA-224, SHA-256, SHA-384, SHA-512, Tiger,
    WHIRLPOOL, RIPEMD-128, RIPEMD-256, RIPEMD-160, RIPEMD-320),
  * Public-key cryptography (RSA, DSA, ElGamal, NR, RW, LUC, LUCELG,
    DLIES, ESIGN),
  * Padding schemes for public-key systems (PKCS#1, OAEP, PSS, PSSR,
    EMSA2, EMSA5),
  * Key agreement schemes (DH, MQV, LUCDIF, XTR-DH),
  * Elliptic curve cryptography (ECDSA, ECNR, ECIES, ECDH, ECMQV),
  * Backwards compatibility algorithms (MD2, MD4, MD5, Panama Hash, DES,
    ARC4, SEAL 3.0, WAKE, WAKE-OFB, DESX, RC2, SAFER, 3-WAY, GOST,
    SHARK, CAST-128, Square),
  * Pseudo-random number generators,
 and a whole lot more.  Alternative libraries are libgcrypt and
 nettle.
 .
 This package contains the header files needed for developing using
 the Crypto++ class library and the static library with libtool
 supoport.

Package: libcrypto++-utils
Architecture: any
Section: utils
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libcrypto++-dev (= 5.2.1c2-1)
Description: General purpose cryptographic library - utilities and data files
 Crypto++ is library for creating C++ programs which use cryptographic
 algorithms.  The library uses a Pipes & Filters architecture with heavy
 use of templates and abstract base classes.  The cryptographic
 tools include:
  * Authenticated encryption schemes (GCM, CCM, EAX),
  * High speed stream ciphers (Panama, Sosemanuk, Salsa20, XSalsa20),
  * AES and candidates (Rijndael, RC6, MARS, Twofish, Serpent, CAST-256),
  * Other symmetric block ciphers (IDEA, Triple-DES, Camellia, SEED,
    RC5, Blowfish, TEA, XTEA, Skipjack, SHACAL-2),
  * Block cipher modes of operation (ECB, CBC, CTS, CFB, OFB, CTR),
  * Message authentication codes (VMAC, HMAC, CMAC, CBC-MAC, DMAC,
    Two-Track-MAC),
  * Hash functions (SHA-1, SHA-224, SHA-256, SHA-384, SHA-512, Tiger,
    WHIRLPOOL, RIPEMD-128, RIPEMD-256, RIPEMD-160, RIPEMD-320),
  * Public-key cryptography (RSA, DSA, ElGamal, NR, RW, LUC, LUCELG,
    DLIES, ESIGN),
  * Padding schemes for public-key systems (PKCS#1, OAEP, PSS, PSSR,
    EMSA2, EMSA5),
  * Key agreement schemes (DH, MQV, LUCDIF, XTR-DH),
  * Elliptic curve cryptography (ECDSA, ECNR, ECIES, ECDH, ECMQV),
  * Backwards compatibility algorithms (MD2, MD4, MD5, Panama Hash, DES,
    ARC4, SEAL 3.0, WAKE, WAKE-OFB, DESX, RC2, SAFER, 3-WAY, GOST,
    SHARK, CAST-128, Square),
  * Pseudo-random number generators,
 and a whole lot more.  Alternative libraries are libgcrypt and
 nettle.
 .
 This package includes a utility for benchmarking and using the
 various Crypto++ routines from the command line.  It also includes
 the test vectors for validating both the Crypto++ implementation and
 other implementations of these routines.

Package: libcrypto++-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, libjs-jquery
Conflicts: libcrypto++-dev (<= 5.2.1c2-3)
Enhances: libcrypto++-dev
Description: General purpose cryptographic library - documentation
 Crypto++ is library for creating C++ programs which use cryptographic
 algorithms.  The library uses a Pipes & Filters architecture with heavy
 use of templates and abstract base classes.  The cryptographic
 tools include:
  * Authenticated encryption schemes (GCM, CCM, EAX),
  * High speed stream ciphers (Panama, Sosemanuk, Salsa20, XSalsa20),
  * AES and candidates (Rijndael, RC6, MARS, Twofish, Serpent, CAST-256),
  * Other symmetric block ciphers (IDEA, Triple-DES, Camellia, SEED,
    RC5, Blowfish, TEA, XTEA, Skipjack, SHACAL-2),
  * Block cipher modes of operation (ECB, CBC, CTS, CFB, OFB, CTR),
  * Message authentication codes (VMAC, HMAC, CMAC, CBC-MAC, DMAC,
    Two-Track-MAC),
  * Hash functions (SHA-1, SHA-224, SHA-256, SHA-384, SHA-512, Tiger,
    WHIRLPOOL, RIPEMD-128, RIPEMD-256, RIPEMD-160, RIPEMD-320),
  * Public-key cryptography (RSA, DSA, ElGamal, NR, RW, LUC, LUCELG,
    DLIES, ESIGN),
  * Padding schemes for public-key systems (PKCS#1, OAEP, PSS, PSSR,
    EMSA2, EMSA5),
  * Key agreement schemes (DH, MQV, LUCDIF, XTR-DH),
  * Elliptic curve cryptography (ECDSA, ECNR, ECIES, ECDH, ECMQV),
  * Backwards compatibility algorithms (MD2, MD4, MD5, Panama Hash, DES,
    ARC4, SEAL 3.0, WAKE, WAKE-OFB, DESX, RC2, SAFER, 3-WAY, GOST,
    SHARK, CAST-128, Square),
  * Pseudo-random number generators,
 and a whole lot more.  Alternative libraries are libgcrypt and
 nettle.
 .
 This package includes the HTML reference guide to the source code.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DOC_PKG_DIR = $(CURDIR)/debian/libcrypto++-doc/

CXXFLAGS+=-DCRYPTOPP_INIT_PRIORITY=250 -DCRYPTOPP_NO_UNALIGNED_DATA_ACCESS \
	  -DNDEBUG

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(CURDIR)/libcrypto++.pc.in $(CURDIR)/config.log
	rm -rf $(CURDIR)/html-docs/
	# these will be re-generated
	rm -f $(CURDIR)/debian/libcrypto++6.links \
		$(CURDIR)/debian/libcrypto++-dev.links

override_dh_auto_configure:
	rm -f $(CURDIR)/GNUmakefile
	cp -f $(CURDIR)/debian/autotools/configure.ac \
		$(CURDIR)/debian/autotools/libcrypto++.pc.in \
		$(CURDIR)/debian/autotools/Makefile.am \
		$(CURDIR)
	autoreconf --verbose --force --install
	dh_auto_configure

override_dh_auto_build-indep:
	doxygen

override_dh_auto_install:
	# use automake
	dh_auto_install
	# install test files
	mkdir -p $(CURDIR)/debian/tmp/usr/share/crypto--/
	cp -a $(CURDIR)/TestVectors $(CURDIR)/debian/tmp/usr/share/crypto--/
	chmod a-x $(CURDIR)/debian/tmp/usr/share/crypto--/TestVectors/*.txt
	cp -a $(CURDIR)/TestData $(CURDIR)/debian/tmp/usr/share/crypto--/
	# install pkg-config file
	mkdir -p $(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/
	cp -a $(CURDIR)/*.pc \
		$(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/
	# generate links files
	sed s/ARCH/${DEB_HOST_MULTIARCH}/g \
		$(CURDIR)/debian/libcrypto++6.links.in \
		>$(CURDIR)/debian/libcrypto++6.links
	sed s/ARCH/${DEB_HOST_MULTIARCH}/g \
		$(CURDIR)/debian/libcrypto++-dev.links.in \
		>$(CURDIR)/debian/libcrypto++-dev.links

override_dh_strip:
	dh_strip --dbg-package=libcrypto++6-dbg

override_dh_auto_test-arch:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
     	# Code to run the package test suite.
	$(CURDIR)/cryptestcwd v
endif

override_dh_auto_test-indep:

override_dh_installdocs:
	dh_installdocs
	if [ -d "$(DOC_PKG_DIR)/usr/share/doc/libcrypto++-doc/html-docs" ]; then \
		mv $(DOC_PKG_DIR)/usr/share/doc/libcrypto++-doc/html-docs \
		$(DOC_PKG_DIR)/usr/share/doc/libcrypto++-doc/html; \
	fi

%:
	dh $@ --parallel

.PHONY: override_dh_auto_clean override_dh_auto_configure \
	override_dh_auto_build-indep override_dh_auto_install \
	override_dh_strip override_dh_installdocs \
	override_dh_auto_test-arch override_dh_auto_test-indep

## libcrypto++ 5.6.4-8+8.0trisquel1

=== debian/changelog ===
libcrypto++ (5.6.4-8+8.0trisquel1) flidas-backports; urgency=medium

  * Backported from bionic

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 26 Mar 2020 17:12:08 +0000

## libcrypto++ 7.0.0

=== debian/changelog ===
libcrypto++ (7.0.0-1) experimental; urgency=medium

  * New upstream release.
  * Library transition to version 2 of soname.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 08 Apr 2018 12:04:05 +0000

libcrypto++ (6.1.0-2) experimental; urgency=medium

  * Update library compatibility symlink (closes: #891662).
  * Remove debug_info from libcrypto++.a library (closes: #880637).
  * Make the package multiarch (closes: #879822).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 27 Feb 2018 21:31:37 +0000

libcrypto++ (6.1.0-1) experimental; urgency=medium

  * New upstream release.
  * Library transition to version 1 of soname.
  * Update debhelper level to 11 .
  * Update Standards-Version to 4.1.3:
    - remove libcrypto++6-dbg package and use the auto-generated one.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 22 Feb 2018 16:51:10 +0000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,14 @@
 Section: libs
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Standards-Version: 4.0.0
-Build-Depends: debhelper (>= 10), automake, autoconf, libtool
+Standards-Version: 4.1.3
+Build-Depends: debhelper (>= 11), automake, autoconf, libtool
 Build-Depends-Indep: doxygen
 Homepage: http://www.cryptopp.com
 
-Package: libcrypto++6
+Package: libcrypto++2
 Architecture: any
+Multi-Arch: same
 Section: libs
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: General purpose cryptographic library - shared library
@@ -17,22 +18,11 @@
  This package contains the shared libraries and should only be
  installed if other packages depend on it.
 
-Package: libcrypto++6-dbg
-Architecture: any
-Section: debug
-Priority: extra
-Depends: libcrypto++6 (= ${binary:Version}), ${misc:Depends}
-Description: General purpose cryptographic library - debug symbols
- General purpose cryptographic library for C++.
- .
- This package contains the debug symbols for the shared library and
- should only be installed if you debugging a program that uses the
- shared library.
-
 Package: libcrypto++-dev
 Architecture: any
+Multi-Arch: same
 Section: libdevel
-Depends: libcrypto++6 (= ${binary:Version}), ${misc:Depends}
+Depends: libcrypto++2 (= ${binary:Version}), ${misc:Depends}
 Description: General purpose cryptographic library - C++ development
  Crypto++ is library for creating C++ programs which use cryptographic
  algorithms.  The library uses a Pipes & Filters architecture with heavy

=== debian/rules ===
--- 
+++ 
@@ -10,12 +10,14 @@
 CXXFLAGS+=-DCRYPTOPP_INIT_PRIORITY=250 -DCRYPTOPP_NO_UNALIGNED_DATA_ACCESS \
 	  -DNDEBUG
 
+SONAME=2
+
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -f $(CURDIR)/libcrypto++.pc.in $(CURDIR)/config.log
 	rm -rf $(CURDIR)/html-docs/
 	# these will be re-generated
-	rm -f $(CURDIR)/debian/libcrypto++6.links \
+	rm -f $(CURDIR)/debian/libcrypto++$(SONAME).links \
 		$(CURDIR)/debian/libcrypto++-dev.links
 
 override_dh_auto_configure:
@@ -44,18 +46,14 @@
 		$(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/
 	# generate links files
 	sed s/ARCH/${DEB_HOST_MULTIARCH}/g \
-		$(CURDIR)/debian/libcrypto++6.links.in \
-		>$(CURDIR)/debian/libcrypto++6.links
+		$(CURDIR)/debian/libcrypto++$(SONAME).links.in \
+		>$(CURDIR)/debian/libcrypto++$(SONAME).links
 	sed s/ARCH/${DEB_HOST_MULTIARCH}/g \
 		$(CURDIR)/debian/libcrypto++-dev.links.in \
 		>$(CURDIR)/debian/libcrypto++-dev.links
 
-override_dh_strip:
-	dh_strip --dbg-package=libcrypto++6-dbg
-
 override_dh_auto_test-arch:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-     	# Code to run the package test suite.
 	$(CURDIR)/cryptestcwd v
 endif
 
@@ -63,15 +61,15 @@
 
 override_dh_installdocs:
 	dh_installdocs
-	if [ -d "$(DOC_PKG_DIR)/usr/share/doc/libcrypto++-doc/html-docs" ]; then \
-		mv $(DOC_PKG_DIR)/usr/share/doc/libcrypto++-doc/html-docs \
-		$(DOC_PKG_DIR)/usr/share/doc/libcrypto++-doc/html; \
+	if [ -d "$(DOC_PKG_DIR)/usr/share/doc/libcrypto++-dev/html-docs" ]; then \
+		mv $(DOC_PKG_DIR)/usr/share/doc/libcrypto++-dev/html-docs \
+		$(DOC_PKG_DIR)/usr/share/doc/libcrypto++-dev/html; \
 	fi
 
 %:
-	dh $@ --parallel
+	dh $@
 
 .PHONY: override_dh_auto_clean override_dh_auto_configure \
 	override_dh_auto_build-indep override_dh_auto_install \
-	override_dh_strip override_dh_installdocs \
+	override_dh_installdocs \
 	override_dh_auto_test-arch override_dh_auto_test-indep

## libcrypto++ 8.1.0

=== debian/changelog ===
libcrypto++ (8.1.0-2) experimental; urgency=medium

  * Backport upstream fix of remove early NEON qualification tests.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 02 Mar 2019 20:11:43 +0000

libcrypto++ (8.1.0-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 27 Feb 2019 00:39:55 +0000

libcrypto++ (8.0.0-1) experimental; urgency=medium

  * New upstream release.
  * Use upstream build system.
  * Library transition to version 8 of soname.
  * Update Standards-Version to 4.3.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 28 Dec 2018 12:18:20 +0000

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Section: libs
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Standards-Version: 4.1.3
+Standards-Version: 4.3.0
 Build-Depends: debhelper (>= 11), automake, autoconf, libtool
 Build-Depends-Indep: doxygen
-Homepage: http://www.cryptopp.com
+Homepage: https://www.cryptopp.com
 
-Package: libcrypto++2
+Package: libcrypto++8
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -22,7 +22,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libcrypto++2 (= ${binary:Version}), ${misc:Depends}
+Depends: libcrypto++8 (= ${binary:Version}), ${misc:Depends}
 Description: General purpose cryptographic library - C++ development
  Crypto++ is library for creating C++ programs which use cryptographic
  algorithms.  The library uses a Pipes & Filters architecture with heavy

=== debian/rules ===
--- 
+++ 
@@ -7,10 +7,12 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DOC_PKG_DIR = $(CURDIR)/debian/libcrypto++-doc/
 
-CXXFLAGS+=-DCRYPTOPP_INIT_PRIORITY=250 -DCRYPTOPP_NO_UNALIGNED_DATA_ACCESS \
-	  -DNDEBUG
+CXXFLAGS+=-DNDEBUG
 
-SONAME=2
+SONAME=8
+
+PREFIX=/usr
+LIBDIR=$(PREFIX)/lib/$(DEB_HOST_MULTIARCH)/
 
 override_dh_auto_clean:
 	dh_auto_clean
@@ -21,20 +23,24 @@
 		$(CURDIR)/debian/libcrypto++-dev.links
 
 override_dh_auto_configure:
-	rm -f $(CURDIR)/GNUmakefile
-	cp -f $(CURDIR)/debian/autotools/configure.ac \
+#	rm -f $(CURDIR)/GNUmakefile
+#	cp -f $(CURDIR)/debian/autotools/configure.ac \
 		$(CURDIR)/debian/autotools/libcrypto++.pc.in \
 		$(CURDIR)/debian/autotools/Makefile.am \
 		$(CURDIR)
-	autoreconf --verbose --force --install
+#	autoreconf --verbose --force --install
 	dh_auto_configure
+
+override_dh_auto_build-arch:
+	PREFIX=$(PREFIX) LIBDIR=$(LIBDIR) dh_auto_build -a \
+	       -- all libcrypto++.pc
 
 override_dh_auto_build-indep:
 	doxygen
 
 override_dh_auto_install:
 	# use automake
-	dh_auto_install
+	PREFIX=$(PREFIX) LIBDIR=$(LIBDIR) dh_auto_install
 	# install test files
 	mkdir -p $(CURDIR)/debian/tmp/usr/share/crypto--/
 	cp -a $(CURDIR)/TestVectors $(CURDIR)/debian/tmp/usr/share/crypto--/
@@ -42,7 +48,7 @@
 	cp -a $(CURDIR)/TestData $(CURDIR)/debian/tmp/usr/share/crypto--/
 	# install pkg-config file
 	mkdir -p $(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/
-	cp -a $(CURDIR)/*.pc \
+#	cp -a $(CURDIR)/*.pc \
 		$(CURDIR)/debian/tmp/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig/
 	# generate links files
 	sed s/ARCH/${DEB_HOST_MULTIARCH}/g \
@@ -54,7 +60,7 @@
 
 override_dh_auto_test-arch:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	$(CURDIR)/cryptestcwd v
+	$(CURDIR)/cryptest v
 endif
 
 override_dh_auto_test-indep:
@@ -70,6 +76,7 @@
 	dh $@
 
 .PHONY: override_dh_auto_clean override_dh_auto_configure \
-	override_dh_auto_build-indep override_dh_auto_install \
+	override_dh_auto_build-arch override_dh_auto_build-indep \
+	override_dh_auto_install \
 	override_dh_installdocs \
 	override_dh_auto_test-arch override_dh_auto_test-indep

## libcrypto++ 8.2.0

=== debian/changelog ===
libcrypto++ (8.2.0-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 29 Apr 2019 17:00:27 +0000

## libcrypto++ 8.4.0

=== debian/changelog ===
libcrypto++ (8.4.0-1) unstable; urgency=medium

  * New upstream release.
  * Update patches.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 02 Jan 2021 08:22:09 +0100

libcrypto++ (8.3.0-3) unstable; urgency=medium

  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 25 Dec 2020 18:16:54 +0100

libcrypto++ (8.3.0-2) experimental; urgency=medium

  * Backport upstream fix for SIGILL on PowerPC.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 22 Dec 2020 20:38:25 +0100

libcrypto++ (8.3.0-1) experimental; urgency=medium

  * New upstream release.
  * Update debhelper level to 13 .
  * Update Standards-Version to 4.5.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 20 Dec 2020 17:35:29 +0100

libcrypto++ (8.2.0-2) experimental; urgency=medium

  * Fix CVE-2019-14318: timing side channel in ECDSA signature generation
    (closes: #934326).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 11 Aug 2019 16:57:18 +0000

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,11 @@
 Section: libs
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Standards-Version: 4.3.0
-Build-Depends: debhelper (>= 11), automake, autoconf, libtool
+Standards-Version: 4.5.1
+Build-Depends: debhelper-compat (= 13), automake, autoconf, libtool
 Build-Depends-Indep: doxygen
 Homepage: https://www.cryptopp.com
+Rules-Requires-Root: no
 
 Package: libcrypto++8
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -21,15 +21,6 @@
 	# these will be re-generated
 	rm -f $(CURDIR)/debian/libcrypto++$(SONAME).links \
 		$(CURDIR)/debian/libcrypto++-dev.links
-
-override_dh_auto_configure:
-#	rm -f $(CURDIR)/GNUmakefile
-#	cp -f $(CURDIR)/debian/autotools/configure.ac \
-		$(CURDIR)/debian/autotools/libcrypto++.pc.in \
-		$(CURDIR)/debian/autotools/Makefile.am \
-		$(CURDIR)
-#	autoreconf --verbose --force --install
-	dh_auto_configure
 
 override_dh_auto_build-arch:
 	PREFIX=$(PREFIX) LIBDIR=$(LIBDIR) dh_auto_build -a \
@@ -72,11 +63,15 @@
 		$(DOC_PKG_DIR)/usr/share/doc/libcrypto++-dev/html; \
 	fi
 
+# skip files failing with "Unknown DWARF DW_OP_255" (see bug#949296)
+override_dh_dwz:
+	dh_dwz --exclude=usr/bin/cryptest \
+		--exclude=usr/lib/$(DEB_HOST_MULTIARCH)/libcrypto++.so.8.4.0
+
 %:
 	dh $@
 
-.PHONY: override_dh_auto_clean override_dh_auto_configure \
-	override_dh_auto_build-arch override_dh_auto_build-indep \
-	override_dh_auto_install \
-	override_dh_installdocs \
+.PHONY: override_dh_auto_clean override_dh_auto_build-arch \
+	override_dh_auto_build-indep override_dh_auto_install \
+	override_dh_installdocs override_dh_dwz \
 	override_dh_auto_test-arch override_dh_auto_test-indep

## libcrypto++ 8.5.0

=== debian/changelog ===
libcrypto++ (8.5.0-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 07 Sep 2021 22:41:51 +0200

=== debian/rules ===
--- 
+++ 
@@ -66,7 +66,7 @@
 # skip files failing with "Unknown DWARF DW_OP_255" (see bug#949296)
 override_dh_dwz:
 	dh_dwz --exclude=usr/bin/cryptest \
-		--exclude=usr/lib/$(DEB_HOST_MULTIARCH)/libcrypto++.so.8.4.0
+		--exclude=usr/lib/$(DEB_HOST_MULTIARCH)/libcrypto++.so.8.5.0
 
 %:
 	dh $@

## libcrypto++ 8.6.0

=== debian/changelog ===
libcrypto++ (8.6.0-2ubuntu1) jammy; urgency=medium

  * debian/patches/correct-arm-arch.patch: Use the correct architecture
    target for armhf.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 19 Dec 2021 12:21:58 -0800

libcrypto++ (8.6.0-2) unstable; urgency=medium

  * Fix armel and armhf link breakage.
  * Update Standards-Version to 4.6.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 25 Sep 2021 19:44:37 +0200

libcrypto++ (8.6.0-1) unstable; urgency=high

  * New upstream release.
  * Fix CVE-2021-40530: ElGamal encryption using a work estimate to size
    encryption exponents instead subgroup order (closes: #993841).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 25 Sep 2021 11:23:06 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,9 @@
 Source: libcrypto++
 Section: libs
 Priority: optional
-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Standards-Version: 4.5.1
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Standards-Version: 4.6.0
 Build-Depends: debhelper-compat (= 13), automake, autoconf, libtool
 Build-Depends-Indep: doxygen
 Homepage: https://www.cryptopp.com

=== debian/rules ===
--- 
+++ 
@@ -66,7 +66,7 @@
 # skip files failing with "Unknown DWARF DW_OP_255" (see bug#949296)
 override_dh_dwz:
 	dh_dwz --exclude=usr/bin/cryptest \
-		--exclude=usr/lib/$(DEB_HOST_MULTIARCH)/libcrypto++.so.8.5.0
+		--exclude=usr/lib/$(DEB_HOST_MULTIARCH)/libcrypto++.so.8.6.0
 
 %:
 	dh $@

## libcrypto++ 8.7.0

=== debian/changelog ===
libcrypto++ (8.7.0-1) unstable; urgency=medium

  * New upstream release (closes: #1012974).
  * Add -fno-devirtualize to CXXFLAGS for GCC 12 not to remove code member
    function needed for self-testing.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 13 Aug 2022 07:22:58 +0200

libcrypto++ (8.6.0-3) unstable; urgency=medium

  * Fix armhf FTBFS (closes: #1001995). 

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 12 Feb 2022 10:39:14 +0100

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,9 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DOC_PKG_DIR = $(CURDIR)/debian/libcrypto++-doc/
 
-CXXFLAGS+=-DNDEBUG
+# -fno-devirtualize is for GCC 12 not to remove code member function needed
+#  for testing
+CXXFLAGS+=-DNDEBUG -fsanitize=unreachable -fno-devirtualize
 
 SONAME=8

## libcrypto++ 8.7.0+git220824

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: libcrypto++
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
+Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Standards-Version: 4.6.0
 Build-Depends: debhelper-compat (= 13), automake, autoconf, libtool
 Build-Depends-Indep: doxygen
@@ -97,6 +96,7 @@
 
 Package: libcrypto++-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Depends: ${misc:Depends}, libjs-jquery
 Conflicts: libcrypto++-dev (<= 5.2.1c2-3)

=== debian/rules ===
--- 
+++ 
@@ -7,9 +7,12 @@
 DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DOC_PKG_DIR = $(CURDIR)/debian/libcrypto++-doc/
 
-# -fno-devirtualize is for GCC 12 not to remove code member function needed
-#  for testing
-CXXFLAGS+=-DNDEBUG -fsanitize=unreachable -fno-devirtualize
+
+include /usr/share/dpkg/architecture.mk
+
+ifneq ($(filter $(DEB_HOST_ARCH),armel powerpc),)
+        export DEB_LDFLAGS_MAINT_APPEND= -latomic
+endif
 
 SONAME=8

=== debian/watch ===
version=3 
opts=uversionmangle=s/^(\d)_?(\d)_?(\d)$/$1.$2.$3/;s/^(\d)_?(\d)$/$1.$2/ \
https://github.com/weidai11/cryptopp/releases .*/CRYPTOPP_(\d[\d_]+)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz|zip)

## libcrypto++ 8.8.0

=== debian/changelog ===
libcrypto++ (8.8.0-1) unstable; urgency=medium

  * New upstream release.

  [ Helmut Grohne <helmut@subdivi.de> ]
  * Fix FTCBFS: Export build tools for all targets (closes: #1018923).


 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 07 Jul 2023 17:20:07 +0200

libcrypto++ (8.7.0+git220824-1) unstable; urgency=medium

  * New git snapshot release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 25 Aug 2022 19:44:25 +0200

## libcrypto++ 8.9.0

=== debian/changelog ===
libcrypto++ (8.9.0-2) unstable; urgency=high

  * Update gf2n documentation.
  * Fix CVE-2023-50980: denial of service (application crash) via DER
    public-key data (closes: #1059311).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 29 Apr 2025 21:12:05 +0200

libcrypto++ (8.9.0-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062265

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 10:39:14 +0000

libcrypto++ (8.9.0-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 02 Oct 2023 17:51:51 +0200

libcrypto++ (8.8.0-2) unstable; urgency=medium

  * Update watch file.
  * Update Standards-Version to 4.6.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 07 Sep 2023 07:25:20 +0000

=== debian/control ===
--- 
+++ 
@@ -2,13 +2,16 @@
 Section: libs
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Standards-Version: 4.6.0
-Build-Depends: debhelper-compat (= 13), automake, autoconf, libtool
+Standards-Version: 4.6.2
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13), automake, autoconf, libtool
 Build-Depends-Indep: doxygen
 Homepage: https://www.cryptopp.com
 Rules-Requires-Root: no
 
-Package: libcrypto++8
+Package: libcrypto++8t64
+Provides: ${t64:Provides}
+Replaces: libcrypto++8
+Breaks: libcrypto++8 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -23,7 +26,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libcrypto++8 (= ${binary:Version}), ${misc:Depends}
+Depends: libcrypto++8t64 (= ${binary:Version}), ${misc:Depends}
 Description: General purpose cryptographic library - C++ development
  Crypto++ is library for creating C++ programs which use cryptographic
  algorithms.  The library uses a Pipes & Filters architecture with heavy

=== debian/rules ===
--- 
+++ 
@@ -4,17 +4,17 @@
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
 
-DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
 DOC_PKG_DIR = $(CURDIR)/debian/libcrypto++-doc/
 
-
+DPKG_EXPORT_BUILDTOOLS=1
 include /usr/share/dpkg/architecture.mk
+include /usr/share/dpkg/buildtools.mk
 
 ifneq ($(filter $(DEB_HOST_ARCH),armel powerpc),)
         export DEB_LDFLAGS_MAINT_APPEND= -latomic
 endif
 
-SONAME=8
+SONAME=8t64
 
 PREFIX=/usr
 LIBDIR=$(PREFIX)/lib/$(DEB_HOST_MULTIARCH)/
